/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/callback/ServerEndPoint.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc. 
 * All rights reserved.
 */
package com.netapp.common.callback;

/**
 * A wrapper class to pass in how to connect to a remote server in order to
 * support the callback mechanism.
 * 
 * In IPv4, the end point would be built as a URL similar to:
 * 
 * <protocol>://<hostname>:<port>/<path>
 * 
 * @author joshb
 * 
 */
public class ServerEndPoint {

    protected String hostname;
    protected int port;
    protected String protocol;
    protected String path;

    public ServerEndPoint() {
        super();
    }

    public ServerEndPoint(String protocol, String hostname, int port, String path) {

        this();
        setHostname(hostname);
        setPort(port);
        setProtocol(protocol);
        setPath(path);
    }

    public String getHostname() {
        return hostname;
    }

    public void setHostname(String hostname) {
        this.hostname = hostname;
    }

    public int getPort() {
        return port;
    }

    public void setPort(int port) {
        this.port = port;
    }

    public String getProtocol() {
        return protocol;
    }

    public void setProtocol(String protocol) {
        this.protocol = protocol;
    }

    public String getPath() {
        return path;
    }

    public void setPath(String path) {
        this.path = path;
    }

}
