/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/cli/validator/ValidatorType.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.cli.validator;

import java.util.regex.Pattern;

import com.netapp.common.MsgKey;

/**
 * @author sirianni
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public enum ValidatorType {
    NOT_NULL, NUMERIC, GUID, FRACTIONAL, SHORT, CHAR;
    
    public Validator getValidator() {
        switch (this) {
            case NOT_NULL:
                return new NotNullValidator();
            case NUMERIC:
                return new RegexValidator(Pattern.compile("[0-9]{1,9}"), MsgKey.CLI_BASE_NUMERIC_PARAMETER_REQUIRED);
            case GUID:
                return new RegexValidator(Pattern.compile("[0-9a-f]{32}"), MsgKey.CLI_BASE_INVALID_GUID);
            case FRACTIONAL:
                return new RegexValidator(Pattern.compile("[0-9]{1,9}[\\.]?[0-9]{0,9}"), MsgKey.CLI_BASE_FRACTIONAL_PARAMETER_REQUIRED);
            case SHORT:
                return new RegexValidator(Pattern.compile("[0-9]{1,5}"), MsgKey.CLI_BASE_SHORT_PARAMATER_REQUIRED);
            case CHAR:
                return new RegexValidator(Pattern.compile(".{0,1}"), MsgKey.CLI_BASE_SEPARATOR_MUST_BE_ONE_CHARACTER);
            default:
                return null;
        }
    }
}
