/*
 * $Id$
 * 
 * Copyright (c) 2008 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.common.execution;


/**
 * @author claird
 * @version $Revision: #2 $ $Date: Jul 2, 2008 $
 */
class UnixUserSwitchingShellCommandTransformer extends ShellCommandTransformer {

    protected String user;
    
    UnixUserSwitchingShellCommandTransformer(String user) {
        super();
        this.user = user;
    }

    UnixUserSwitchingShellCommandTransformer(ShellCommandTransformer shellCommandTransformer, String user) {
        super(shellCommandTransformer);
        this.user = user;
    }

    /**
     * @see com.netapp.common.execution.ShellCommandTransformer#performTransformation(com.netapp.common.execution.ShellRunnable)
     */
    @Override
    protected ShellRunnable performTransformation(ShellRunnable shellCommand) {
        String commandString = createQuotedCommandString(shellCommand);
        ShellRunnable suCommand = shellCommand.transformInto("su", this.user, "-c", commandString);
        
        return new StackedShellCommand(suCommand, shellCommand);
    }

}
