/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/flow/UnableToAcquireLockException.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.flow;

import java.util.Set;


/**
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class UnableToAcquireLockException extends Exception {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    private OperationId currentHolderId;
    private Set<String> locks;
    
    public UnableToAcquireLockException(OperationId currentHolderId, Set<String> locks, String message) {
        super(message);
        this.currentHolderId = currentHolderId;
        this.locks = locks;
    }
    
    public UnableToAcquireLockException(OperationId currentHolderId, Set<String> lock, String message, Throwable cause) {
        super(message, cause);
        this.currentHolderId = currentHolderId;
        this.locks = lock;
    }
    
    /**
     * @return Returns the currentHolderId.
     */
    public OperationId getCurrentHolderId() {
        return currentHolderId;
    }

    /**
     * @return Returns the lock.
     */
    public Set<String> getLocks() {
        return locks;
    }
}
