/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/bootstrap/com/netapp/common/logging/MessageKey.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.logging;

import java.util.regex.Pattern;

import javax.xml.bind.annotation.XmlType;

/**
 * Interface for generated MsgKey enumerations.
 * @see com.netapp.common.logging.generator.MsgKeyGenerator
 * 
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
@XmlType
public interface MessageKey {
    /**
     * Regex for APPL-01234 codes.
     */
    Pattern CODE_PATTERN = Pattern.compile("^(\\w+-\\d+):.*", Pattern.DOTALL);
    
    /**
     * Return the property bundle key for this enum.
     * @return The property name used to generate this enum
     */
    String getPropertyName();
    
    /**
     * Returns the name of this enum constant, exactly as declared in its enum declaration.
     * Defined and implemented by java.lang.Enum.
     * @return the name of this enum constant
     */
    String name();
}
