/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/platform/linux/AbstractBlockDeviceHandler.java#1 $
 * 
 * Copyright (c) 2008 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.common.platform.linux;

import com.netapp.common.MsgKey;
import com.netapp.common.execution.ShellExecutor;
import com.netapp.common.execution.ShellExecutorFactory;
import com.netapp.common.logging.NALogger;

public abstract class AbstractBlockDeviceHandler implements BlockDeviceHandler {
    private static final NALogger logger = NALogger.getLogger(AbstractBlockDeviceHandler.class);
    protected OperatingSystemImpl operatingSystem;
    protected ShellExecutor shellExecutor;
    
    public AbstractBlockDeviceHandler(OperatingSystemImpl operatingSystem) {
        this.operatingSystem = operatingSystem;
    }

    protected synchronized ShellExecutor getShellExecutor() {
        if (this.shellExecutor == null) {
            if (this.operatingSystem != null) {
                this.shellExecutor = ShellExecutorFactory.createShellExecutor();
            }
            else {
                throw new RuntimeException(
                    logger.error(MsgKey.PLATFORM_NO_IMPLEMENTATION));
            }
        }
        return this.shellExecutor;
    }
}