/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/util/TransformerChain.java#1 $
 * 
 * Copyright (c) 2009 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.common.util;

/**
 * Adapt a chain of transformers to the {@link Transformer} interface.
 * 
 * @author sirianni
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
@SuppressWarnings("unchecked")
public class TransformerChain<S, T> implements Transformer<S, T> {

    private Transformer[] transformers;

    public TransformerChain(Transformer... transformers) {
        this.transformers = transformers;
    }
    
    /**
     * Helper method for creating a TransformerChain in a type-safe manner
     */
    public static <A, B, C> TransformerChain<A, C> newInstance(Transformer<A, B> transformer1, Transformer<B, C> transformer2) {
        return new TransformerChain<A, C>(transformer1, transformer2);
    }
    
    public T transform(S a) {
        Object result = a;
        for (Transformer transformer : this.transformers) {
            result = transformer.transform(result);
        }
        return (T) result;
    }

}
