/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/ZAPIExecuteException.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi;

import netapp.manage.NaAPIFailedException;

/**
 * Thrown when a ZAPI call returns an in-band error.
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class ZAPIExecuteException extends Exception {

    /**
     * Thrown when a ZAPI call returns an in-band error.
     */
    private static final long serialVersionUID = 1L;
    private final NaAPIFailedException cause;
    
    public ZAPIExecuteException(NaAPIFailedException cause) {
        super(cause.getMessage(), cause);
        this.cause = cause;
    }
    
    /**
     * Retrieve the error number for this failure
     * @return error number
     */
    public int getErrno() {
        return this.cause.getErrno();
    }
    
    /**
     * Return a human-readable string describing this failure
     * @return error message
     */
    public String getReason() {
        return this.cause.getReason();
    }
}
