/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/parser/Category.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi.parser;

import java.util.Queue;

/**
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class Category implements Comparable<Category> {
    private String name;
    private String synopsis;
    private String discussion;
    
    public Category(String name) {
        this.name = name;
    }
    
    /**
     * Populate elements from the supplied queue of tags, stopping at the first
     * unknown tag.
     * @param q
     */
    public void populate(Queue<Tag> q) {
        Tag tag = q.peek();
        while (tag != null) {
            if (tag.is(TagEnum.SYNOPSIS)) {
                this.synopsis = tag.getValue();
            }
            else if (tag.is(TagEnum.DISCUSSION)) {
                this.discussion = tag.getValue();
            }
            else {
                // Tag not recognized
                break;
            }
            // Remove the one we were looking at
            q.poll();
            
            // Peek at the next one
            tag = q.peek();
        }
    }
    
    public String getName() {
        return this.name;
    }
    
    public String getSynopsis() {
        return this.synopsis;
    }
    
    public String getDiscussion() {
        return this.discussion;
    }
    
    @Override
    public int hashCode() {
        return this.name.hashCode();
    }
    
    public int compareTo(Category obj) {
        return this.name.compareTo(obj.name);
    }
}
