/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/parser/OutputFile.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi.parser;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

/**
 * Wrapper containing a generated file to be written.
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
class OutputFile {
    
    File directory;
    
    /** Name of the file to create */
    String name;
    
    /** Generated contents for this file */
    String contents;

    /** 
     * Construct a new OutputFile with the specified name 
     * @param name Name of new file
     */
    OutputFile(File directory, String name) {
        this.directory = directory;
        this.name = name;
    }
    
    /**
     * Get the name of the file
     * @return
     */
    String getName() {
        return this.name;
    }
    
    /**
     * Set the contents of the file
     * @param contents
     */
    void setContents(String contents) {
        this.contents = contents;
    }
    
    /**
     * Get the contents of the file
     * @return file contents
     */
    String getContents() {
        return this.contents;
    }
    
    /**
     * Write this file in the specified directory
     * @param outputDir directory to create this file in
     * @throws IOException
     */
    void write() throws IOException {
        assert contents != null;
        File file = new File(this.directory, this.name);
        FileWriter writer = new FileWriter(file);
        
        //generateFileHeader(writer);
        writer.write(contents);
        writer.flush();
        writer.close();
    }
}